/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.enums.EnumTransCategory;
import de.ship.db.tables.records.VCoreElementLabelRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreElementLabel extends TableImpl<VCoreElementLabelRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_element_label</code>
     */
    public static final VCoreElementLabel V_CORE_ELEMENT_LABEL = new VCoreElementLabel();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreElementLabelRecord> getRecordType() {
        return VCoreElementLabelRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_element_label.unique_name</code>.
     */
    public final TableField<VCoreElementLabelRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_element_label.fk_element</code>.
     */
    public final TableField<VCoreElementLabelRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_element_label.value</code>.
     */
    public final TableField<VCoreElementLabelRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_element_label.isocode</code>.
     */
    public final TableField<VCoreElementLabelRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.v_core_element_label.category</code>.
     */
    public final TableField<VCoreElementLabelRecord, EnumTransCategory> CATEGORY = createField(DSL.name("category"), SQLDataType.VARCHAR.asEnumDataType(EnumTransCategory.class), this, "");

    private VCoreElementLabel(Name alias, Table<VCoreElementLabelRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreElementLabel(Name alias, Table<VCoreElementLabelRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_element_label" as  SELECT e.unique_name,
         e.key_element AS fk_element,
         t.value,
         t.isocode,
         t.category
        FROM (common_dd.t_core_element_hierarchy e
          LEFT JOIN common_dd.t_core_translation t ON ((t.fk_trans_key = e.hier_lang)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_element_label</code> table
     * reference
     */
    public VCoreElementLabel(String alias) {
        this(DSL.name(alias), V_CORE_ELEMENT_LABEL);
    }

    /**
     * Create an aliased <code>common_dd.v_core_element_label</code> table
     * reference
     */
    public VCoreElementLabel(Name alias) {
        this(alias, V_CORE_ELEMENT_LABEL);
    }

    /**
     * Create a <code>common_dd.v_core_element_label</code> table reference
     */
    public VCoreElementLabel() {
        this(DSL.name("v_core_element_label"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreElementLabel as(String alias) {
        return new VCoreElementLabel(DSL.name(alias), this);
    }

    @Override
    public VCoreElementLabel as(Name alias) {
        return new VCoreElementLabel(alias, this);
    }

    @Override
    public VCoreElementLabel as(Table<?> alias) {
        return new VCoreElementLabel(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementLabel rename(String name) {
        return new VCoreElementLabel(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementLabel rename(Name name) {
        return new VCoreElementLabel(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementLabel rename(Table<?> name) {
        return new VCoreElementLabel(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementLabel where(Condition condition) {
        return new VCoreElementLabel(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementLabel where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementLabel where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementLabel where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementLabel where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementLabel where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementLabel where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementLabel where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementLabel whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementLabel whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
